/*
  $Header: d:\\Personal\\cvs/aj/src/aspects/Profiler.java,v 1.2 2002/01/27 17:05:09 ikk Exp $ $Name:  $

  $Log: Profiler.java,v $
  Revision 1.2  2002/01/27 17:05:09  ikk
  Formatting changes.

  Revision 1.1  2002/01/27 17:03:13  ikk
  Initial.

*/

package aspects;

import java.io.*;
import org.aspectj.lang.SoftException;

public aspect Profiler
{
    public static final String cvs="$Id: Profiler.java,v 1.2 2002/01/27 17:05:09 ikk Exp $";

    pointcut prof(): call(* *.*(..)) && !within(aspects.*);

    FileOutputStream out;

    public Profiler() throws FileNotFoundException
    {
        out = new FileOutputStream("profile.txt");
    }

    before() : prof() 
    {
        String record = "+ " +
          Thread.currentThread().hashCode()+" "+
          Long.toString(System.currentTimeMillis())+" "+
          thisJoinPointStaticPart.getSignature()+"\n";

        try
        {
            out.write(record.getBytes());
        }
        catch(IOException e)
        {
            throw new SoftException(e);
        }
    }

    after() : prof()
    {
        String record ="- "+
          Thread.currentThread().hashCode()+" "+
          Long.toString(System.currentTimeMillis())+" "+
          thisJoinPointStaticPart.getSignature()+"\n";

        try
        {
            out.write(record.getBytes());
        }
        catch(IOException e)
        {
            throw new SoftException(e);
        }
    }
}

