/*
  $Header: d:\\Personal\\cvs/aj/src/aspects/ReadCache.java,v 1.1 2002/02/09 05:28:52 ikk Exp $ $Name:  $

  $Log: ReadCache.java,v $
  Revision 1.1  2002/02/09 05:28:52  ikk
  Initial.

*/

package aspects;

import java.sql.*;
import java.util.*;

public aspect ReadCache
{
    public static final String cvs="$Id: ReadCache.java,v 1.1 2002/02/09 05:28:52 ikk Exp $";

    private static Map cache = new HashMap();

    pointcut read(String user):
    call(Collection StoriesDb.retrieve(String)) && args(user);

    pointcut dirtyUser(String user):
    call(* StoriesDb.savePreferences(String, ..)) && args(user);
    
    pointcut dirtyAll():
    call(* StoriesDb.saveStory(..));

    Collection around(String user) throws SQLException: read(user)
    {
        Collection res = (Collection)cache.get(user);
        if(null == res)
        {
            res = proceed();
            cache.put(user, res);
        }
        return res;
    }

    after(String user): dirtyUser(user)
    {
        cache.remove(user);
    }

    after(): dirtyAll()
    {
        cache.clear();
    }
}
